# kontrollstrukturen.py

### ----- Verzweigungen -----
zahl = int(input('Ganze Zahl eingeben: '))

if zahl>0:
    print ('Zahl ist positiv')
elif zahl<0:
    print ('Zahl ist negativ')
else:
    print ('Zahl ist null')

# bedingte Ausdruecke
print ('Zahl ist negativ' if zahl<0 else 'Zahl ist nicht negativ')

### ----- Wiederholungen -----
#for
print("Quadratzahlen")
for i in range(5):
    print(i, i*i )

text=('Die Katze jagt den Hund')
for wort in text.split(' '):
    if wort=='Hund':
        print ('Wort "Hund"','gefunden in ','"'+text+'"')

#### Das geht auch einfacher:
##if "Hund" in text:
##    print ('Wort "Hund"','gefunden in ','"'+text+'"')

# while
while zahl>0:          # Laufbedingung
    print(zahl)
    zahl -= 1

### ----- Rekursion -----
# eigentlich keine Kontrollstruktur
def summeBis(zahl):
    if zahl<=0:      ## Abbruchbedingung
        return 0
    else:            ## rekursiver Aufruf
        return zahl + summeBis(zahl-1)

print (summeBis(100))

# Verzeigung bei return vereinfacht:
def summeBisKurz(zahl):
    if zahl<=0:      ## Abbruchbedingung
        return 0
    ## rekursiver Aufruf ohne else als Alternative
    return zahl + summeBisKurz(zahl-1)

print (summeBisKurz(100))

# oder auch - wie oft als Beispiel gewählt -
# Fibonaccizahlen

def fibonacci(n):
    if n<0: return 0
    if n==1: return 1
    return fibonacci(n-1) + fibonacci(n-2)

for i in range(8):
    print(i,' -> ', fibonacci(i))

# "optimiert" mit Datenstruktur Dictionary:
fibDict={0:0 , 1:1}
def fibo(n):
    if n in fibDict: return fibDict[n]
    neu = fibo(n-1) + fibo(n-2)
    fibDict.update({n:neu})
    print(fibDict)
    return neu

for i in range(8):
    print(i,' -> ', fibo(i))
